<?php
  echo "--- Conversion en booléen de valeurs fausses ---".PHP_EOL;
 // cas d'un entier
 $i=0;
 echo '$i='.$i.PHP_EOL;
 var_dump($i);
 $bi=(boolean) $i;
 if ($bi) echo '$bi=vrai'.PHP_EOL; else echo '$bi=faux'.PHP_EOL;
 var_dump($bi);
 // cas d'un réel
 $x=0.0; 
 echo '$x='.$x.PHP_EOL;
 var_dump($x);
 $bx=(boolean) $x;
 if ($bx) echo '$bx=vrai'.PHP_EOL; else echo '$bx=faux'.PHP_EOL;
 var_dump($bx);
 // cas d'une chaîne
 // contenant "0"
 $ch="0"; 
 echo '$ch='.$ch.PHP_EOL;
 var_dump($ch);
 $bch=(boolean) $ch;
 if ($bch) echo '$bch=vrai'.PHP_EOL; else echo '$bch=faux'.PHP_EOL;
 var_dump($bch);
  // contenant vide
 $ch=""; 
 echo '$ch='.$ch.PHP_EOL;
 var_dump($ch);
 $bch=(boolean) $ch;
 if ($bch) echo '$bch=vrai'.PHP_EOL; else echo '$bch=faux'.PHP_EOL;
 var_dump($bch);
 // cas d'un type non défini NULL
 $n=NULL;
 echo '$n='.$n.PHP_EOL;
 var_dump($n);
 $bn=(boolean) $n;
 if ($bn) echo '$bn=vrai'.PHP_EOL; else echo '$bn=faux'.PHP_EOL;
 var_dump($bn);

 // cas d'un tableau vide
 $tableau = [];
 var_dump($tableau);
 $btableau=(boolean) $tableau;
 if ($btableau) echo '$btableau=vrai'.PHP_EOL; else echo '$btableau=faux'.PHP_EOL;
 var_dump($btableau);

 echo "--- Conversion en booléen de valeurs vraies ---".PHP_EOL;
 // cas d'un entier
 $i=-18;
 echo '$i='.$i.PHP_EOL;
 var_dump($i);
 $bi=(boolean) $i;
 if ($bi) echo '$bi=vrai'.PHP_EOL; else echo '$bi=faux'.PHP_EOL;
 var_dump($bi);
 // cas d'un réel
 $x=-18.0; 
 echo '$x='.$x.PHP_EOL;
 var_dump($x);
 $bx=(boolean) $x;
 if ($bx) echo '$bx=vrai'.PHP_EOL; else echo '$bx=faux'.PHP_EOL;
 var_dump($bx);
 // cas d'une chaîne
 // contenant "0"
 $ch="-18"; 
 echo '$ch='.$ch.PHP_EOL;
 var_dump($ch);
 $bch=(boolean) $ch;
 if ($bch) echo '$bch=vrai'.PHP_EOL; else echo '$bch=faux'.PHP_EOL;
 var_dump($bch);

 // cas d'un tableau nonvide
 $tableau = ["val1"];
 var_dump($tableau);
 $btableau=(boolean) $tableau;
 if ($btableau) echo '$btableau=vrai'.PHP_EOL; else echo '$btableau=faux'.PHP_EOL;
 var_dump($btableau);



?>